#!/usr/bin/env python

import rospy
import std_srvs.srv 
from std_msgs.msg import String
from sensor_msgs.msg import Image
# Ros Messages
from sensor_msgs.msg import CompressedImage
# We do not use cv_bridge it does not support CompressedImage in python
# from cv_bridge import CvBridge, CvBridgeError


import time
from picamera.array import PiRGBArray
from picamera import PiCamera

import sys

import cv2
import numpy as np;
#from matplotlib import pyplot as plt

from array import *

from dateutil import parser
from dateutil import tz
from datetime import datetime
from datetime import timedelta

from threading import Thread



global b_capture
global b_img_show



def callback_camera_start(req):

    print "callback_camera_start Response"
    
    global b_capture
    b_capture=True
    
    
    return std_srvs.srv.EmptyResponse();
    
    #return std_srvs.srv.TriggerResponse(True,'waypoint 1');

    
def callback_camera_stop(req):

    print "callback_camera_stop Response"
    #thread_capture.exit()
    global b_capture
    b_capture=False
    #return std_srvs.srv.TriggerResponse(True,'waypoint 1');
    return std_srvs.srv.EmptyResponse();

    
def capture():
    
    global b_capture
    
    print b_capture
    while not rospy.is_shutdown():
        
        if not b_capture:
            rospy.sleep(1)
            
        else:
        
            # capture frames from the camera
            for frame in camera.capture_continuous(rawCapture, format="bgr", use_video_port=True):
                imggray = cv2.cvtColor(frame.array, cv2.COLOR_BGR2GRAY)
                if b_img_show:
                    # show the frame
                    cv2.imshow("Frame", imggray)
                    key = cv2.waitKey(1) & 0xFF
                    
                msg = CompressedImage()
                msg.header.stamp = rospy.Time.now()
                msg.format = "jpeg"
                msg.data = np.array(cv2.imencode('.jpg', imggray)[1]).tostring()
                pub_img_compressed.publish(msg)
                #msg_frame = CvBridge()
                #pub_videoRaw.publish(msg_frame.cv2_to_imgmsg(imggray), "bgr8")
                
                # clear the stream in preparation for the next frame
                rawCapture.truncate(0)
                
                # if the `q` key was pressed, break from the loop
                if key == ord("q"):
                    break
                
                if rospy.is_shutdown():
                    break
                
                if not b_capture:
                    rawCapture.truncate(0)
                    break
                
    print "shutdown"
  
        

if __name__ == "__main__":
    rospy.init_node('picamera_node')
    
    rospy.Service('picamera_node/camera_start',std_srvs.srv.Empty,callback_camera_start)
    rospy.Service('picamera_node/camera_stop',std_srvs.srv.Empty,callback_camera_stop)
    pub_videoRaw = rospy.Publisher('picamera_node/image_raw', Image, queue_size=1)
    pub_img_compressed = rospy.Publisher("picamera_node/image_raw/compressed",CompressedImage, queue_size=1)
    #pub_msg_array=rospy.Publisher('picamera_node/ir_array', IrArray)
    
    camera = PiCamera()
    #camera.resolution = (640,480)
    camera.sharpness = 0
    camera.contrast = 10
    #camera.brightness = 20
    camera.saturation = 0
    camera.ISO = 0
    camera.video_stabilization = False
    camera.exposure_compensation = 0
    camera.exposure_mode = 'auto'
    camera.meter_mode = 'average'
    camera.awb_mode = 'auto'
    camera.image_effect = 'none'
    camera.color_effects = None
    camera.rotation = 0
    camera.hflip = False
    camera.vflip = False
    camera.crop = (0.0, 0.0, 1.0, 1.0)
    camera.framerate = 32
    
    camera.resolution=(rospy.get_param('~image_width', 320),rospy.get_param('~image_height', 240))
    camera.framerate=rospy.get_param('~framerate', 30)
    camera.brightness=rospy.get_param('~brightness', 20)
    
    
    print "camera.brightness" ,camera.brightness
    rawCapture = PiRGBArray(camera, size=camera.resolution)
    
    global b_capture
    b_capture=rospy.get_param('~enable_capture', True)
    
    global b_img_show
    b_img_show=rospy.get_param('~show_img', True)
    
    thread_capture = Thread(target=capture)
    thread_capture.start()
    

    
    print "Started"
    rospy.spin()
