# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from base_control_msgs/Control_state.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import base_control_msgs.msg
import std_msgs.msg

class Control_state(genpy.Message):
  _md5sum = "c0ebd1ee7609f1b11d7c98154e81261d"
  _type = "base_control_msgs/Control_state"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """Header header

# GPMRC STATE

#Global
string contr_name     #Firmware version

float32 volt_values     #Voltage values vector

#Motors state
AxisData[] axes    #Vector of motor states

#Digital state
int32[] digout_state  #Digital state vector

#Alarm monitoring
bool[] alarms







================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: base_control_msgs/AxisData
#Axis data
int32 vel #Velocity in encoder pulses per second
int32 odo #Total count in pulses
bool cal #whether the axis is calibrated or not

"""
  __slots__ = ['header','contr_name','volt_values','axes','digout_state','alarms']
  _slot_types = ['std_msgs/Header','string','float32','base_control_msgs/AxisData[]','int32[]','bool[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,contr_name,volt_values,axes,digout_state,alarms

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(Control_state, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.contr_name is None:
        self.contr_name = ''
      if self.volt_values is None:
        self.volt_values = 0.
      if self.axes is None:
        self.axes = []
      if self.digout_state is None:
        self.digout_state = []
      if self.alarms is None:
        self.alarms = []
    else:
      self.header = std_msgs.msg.Header()
      self.contr_name = ''
      self.volt_values = 0.
      self.axes = []
      self.digout_state = []
      self.alarms = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.contr_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      buff.write(_get_struct_f().pack(self.volt_values))
      length = len(self.axes)
      buff.write(_struct_I.pack(length))
      for val1 in self.axes:
        _x = val1
        buff.write(_get_struct_2iB().pack(_x.vel, _x.odo, _x.cal))
      length = len(self.digout_state)
      buff.write(_struct_I.pack(length))
      pattern = '<%si'%length
      buff.write(struct.pack(pattern, *self.digout_state))
      length = len(self.alarms)
      buff.write(_struct_I.pack(length))
      pattern = '<%sB'%length
      buff.write(struct.pack(pattern, *self.alarms))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.axes is None:
        self.axes = None
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.contr_name = str[start:end].decode('utf-8')
      else:
        self.contr_name = str[start:end]
      start = end
      end += 4
      (self.volt_values,) = _get_struct_f().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.axes = []
      for i in range(0, length):
        val1 = base_control_msgs.msg.AxisData()
        _x = val1
        start = end
        end += 9
        (_x.vel, _x.odo, _x.cal,) = _get_struct_2iB().unpack(str[start:end])
        val1.cal = bool(val1.cal)
        self.axes.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%si'%length
      start = end
      end += struct.calcsize(pattern)
      self.digout_state = struct.unpack(pattern, str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sB'%length
      start = end
      end += struct.calcsize(pattern)
      self.alarms = struct.unpack(pattern, str[start:end])
      self.alarms = map(bool, self.alarms)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.contr_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.pack('<I%ss'%length, length, _x))
      buff.write(_get_struct_f().pack(self.volt_values))
      length = len(self.axes)
      buff.write(_struct_I.pack(length))
      for val1 in self.axes:
        _x = val1
        buff.write(_get_struct_2iB().pack(_x.vel, _x.odo, _x.cal))
      length = len(self.digout_state)
      buff.write(_struct_I.pack(length))
      pattern = '<%si'%length
      buff.write(self.digout_state.tostring())
      length = len(self.alarms)
      buff.write(_struct_I.pack(length))
      pattern = '<%sB'%length
      buff.write(self.alarms.tostring())
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.axes is None:
        self.axes = None
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.contr_name = str[start:end].decode('utf-8')
      else:
        self.contr_name = str[start:end]
      start = end
      end += 4
      (self.volt_values,) = _get_struct_f().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.axes = []
      for i in range(0, length):
        val1 = base_control_msgs.msg.AxisData()
        _x = val1
        start = end
        end += 9
        (_x.vel, _x.odo, _x.cal,) = _get_struct_2iB().unpack(str[start:end])
        val1.cal = bool(val1.cal)
        self.axes.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%si'%length
      start = end
      end += struct.calcsize(pattern)
      self.digout_state = numpy.frombuffer(str[start:end], dtype=numpy.int32, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sB'%length
      start = end
      end += struct.calcsize(pattern)
      self.alarms = numpy.frombuffer(str[start:end], dtype=numpy.bool, count=length)
      self.alarms = map(bool, self.alarms)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_2iB = None
def _get_struct_2iB():
    global _struct_2iB
    if _struct_2iB is None:
        _struct_2iB = struct.Struct("<2iB")
    return _struct_2iB
_struct_f = None
def _get_struct_f():
    global _struct_f
    if _struct_f is None:
        _struct_f = struct.Struct("<f")
    return _struct_f
