// Auto-generated. Do not edit!

// (in-package base_control_msgs.msg)


"use strict";

let _serializer = require('../base_serialize.js');
let _deserializer = require('../base_deserialize.js');
let _finder = require('../find.js');
let AxisData = require('./AxisData.js');
let std_msgs = _finder('std_msgs');

//-----------------------------------------------------------

class Control_state {
  constructor() {
    this.header = new std_msgs.msg.Header();
    this.contr_name = '';
    this.volt_values = 0.0;
    this.axes = [];
    this.digout_state = [];
    this.alarms = [];
  }

  static serialize(obj, bufferInfo) {
    // Serializes a message object of type Control_state
    // Serialize message field [header]
    bufferInfo = std_msgs.msg.Header.serialize(obj.header, bufferInfo);
    // Serialize message field [contr_name]
    bufferInfo = _serializer.string(obj.contr_name, bufferInfo);
    // Serialize message field [volt_values]
    bufferInfo = _serializer.float32(obj.volt_values, bufferInfo);
    // Serialize the length for message field [axes]
    bufferInfo = _serializer.uint32(obj.axes.length, bufferInfo);
    // Serialize message field [axes]
    obj.axes.forEach((val) => {
      bufferInfo = AxisData.serialize(val, bufferInfo);
    });
    // Serialize the length for message field [digout_state]
    bufferInfo = _serializer.uint32(obj.digout_state.length, bufferInfo);
    // Serialize message field [digout_state]
    obj.digout_state.forEach((val) => {
      bufferInfo = _serializer.int32(val, bufferInfo);
    });
    // Serialize the length for message field [alarms]
    bufferInfo = _serializer.uint32(obj.alarms.length, bufferInfo);
    // Serialize message field [alarms]
    obj.alarms.forEach((val) => {
      bufferInfo = _serializer.bool(val, bufferInfo);
    });
    return bufferInfo;
  }

  static deserialize(buffer) {
    //deserializes a message object of type Control_state
    let tmp;
    let len;
    let data = new Control_state();
    // Deserialize message field [header]
    tmp = std_msgs.msg.Header.deserialize(buffer);
    data.header = tmp.data;
    buffer = tmp.buffer;
    // Deserialize message field [contr_name]
    tmp = _deserializer.string(buffer);
    data.contr_name = tmp.data;
    buffer = tmp.buffer;
    // Deserialize message field [volt_values]
    tmp = _deserializer.float32(buffer);
    data.volt_values = tmp.data;
    buffer = tmp.buffer;
    // Deserialize array length for message field [axes]
    tmp = _deserializer.uint32(buffer);
    len = tmp.data;
    buffer = tmp.buffer;
    // Deserialize message field [axes]
    data.axes = new Array(len);
    for (let i = 0; i < len; ++i) {
      tmp = AxisData.deserialize(buffer);
      data.axes[i] = tmp.data;
      buffer = tmp.buffer;
    }
    // Deserialize array length for message field [digout_state]
    tmp = _deserializer.uint32(buffer);
    len = tmp.data;
    buffer = tmp.buffer;
    // Deserialize message field [digout_state]
    data.digout_state = new Array(len);
    for (let i = 0; i < len; ++i) {
      tmp = _deserializer.int32(buffer);
      data.digout_state[i] = tmp.data;
      buffer = tmp.buffer;
    }
    // Deserialize array length for message field [alarms]
    tmp = _deserializer.uint32(buffer);
    len = tmp.data;
    buffer = tmp.buffer;
    // Deserialize message field [alarms]
    data.alarms = new Array(len);
    for (let i = 0; i < len; ++i) {
      tmp = _deserializer.bool(buffer);
      data.alarms[i] = tmp.data;
      buffer = tmp.buffer;
    }
    return {
      data: data,
      buffer: buffer
    }
  }

  static datatype() {
    // Returns string type for a message object
    return 'base_control_msgs/Control_state';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return 'c0ebd1ee7609f1b11d7c98154e81261d';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    Header header
    
    # GPMRC STATE
    
    #Global
    string contr_name     #Firmware version
    
    float32 volt_values     #Voltage values vector
    
    #Motors state
    AxisData[] axes    #Vector of motor states
    
    #Digital state
    int32[] digout_state  #Digital state vector
    
    #Alarm monitoring
    bool[] alarms
    
    
    
    
    
    
    
    ================================================================================
    MSG: std_msgs/Header
    # Standard metadata for higher-level stamped data types.
    # This is generally used to communicate timestamped data 
    # in a particular coordinate frame.
    # 
    # sequence ID: consecutively increasing ID 
    uint32 seq
    #Two-integer timestamp that is expressed as:
    # * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
    # * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
    # time-handling sugar is provided by the client library
    time stamp
    #Frame this data is associated with
    # 0: no frame
    # 1: global frame
    string frame_id
    
    ================================================================================
    MSG: base_control_msgs/AxisData
    #Axis data
    int32 vel #Velocity in encoder pulses per second
    int32 odo #Total count in pulses
    bool cal #whether the axis is calibrated or not
    
    
    `;
  }

};

module.exports = Control_state;
