#!/usr/bin/env python
# coding: Latin-1

# Simple example of a motor sequence script

# Import library functions we need
import PicoBorgRev
import time

# Setup the PicoBorg Reverse
PBR_L = PicoBorgRev.PicoBorgRev()     # Create a new PicoBorg Reverse object
PBR_L.i2cAddress = 10
PBR_L.Init()                          # Set the board up (checks the board is connected)
PBR_L.ResetEpo()                      # Reset the stop switch (EPO) state
                                    # if you do not have a switch across the two pin header then fit the jumper

PBR_L.SetCommsFailsafe(False)


# Setup the PicoBorg Reverse
PBR_R = PicoBorgRev.PicoBorgRev()     # Create a new PicoBorg Reverse object
PBR_R.i2cAddress = 11
PBR_R.Init()                          # Set the board up (checks the board is connected)
PBR_R.ResetEpo()                      # Reset the stop switch (EPO) state
                                    # if you do not have a switch across the two pin header then fit the jumper

PBR_R.SetCommsFailsafe(False)
#PBR.SetEncoderMoveMode(True)
#PBR.SetEncoderSpeed(0.4) 

# Set our sequence, pairs of motor 1 and motor 2 drive levels
sequence = [

            [+0.2, -0.2],
            [+0.25, -0.25],
            [+0.3, -0.3],
            [+0.35, -0.35],
            [+0.4, -0.4],
            [+0.45, -0.45],
            [+0.5, -0.5],
            [+0.55, -0.55],
            [+0.6, -0.6],
            [+0.7, -0.7],
            [+0.6, -0.6],
            [+0.4, -0.4],
            [+0.2, -0.2],
            [+0.0, +0.0],
           ]
stepDelay = 2.0                     # Number of seconds between each sequence step

# Loop over the sequence until the user presses CTRL+C
print 'Press CTRL+C to finish'
try:
    while True:
#        PBR.EncoderMoveMotors(20000) 
        # Go through each entry in the sequence in order
        for step in sequence:
            PBR_L.SetMotor1(step[0])                  # Set the first motor to the first value in the pair
            #PBR.SetMotor2(step[1])                  # Set the second motor to the second value in the pair
            
            print '%+.1f %+.1f' % (step[0], step[1])
            drivestatus=PBR_L.GetDriveFault()
            print "drivestatus= ",drivestatus
            commstatus=PBR_L.GetCommsFailsafe()
            print "commstatus= ",commstatus
            epostatus=PBR_L.GetEpo()
            print "epostatus= ",epostatus
            
            PBR_R.SetMotor1(step[1])                  # Set the first motor to the first value in the pair
            #PBR.SetMotor2(step[1])                  # Set the second motor to the second value in the pair
            
            drivestatus=PBR_R.GetDriveFault()
            print "drivestatus= ",drivestatus
            commstatus=PBR_R.GetCommsFailsafe()
            print "commstatus= ",commstatus
            epostatus=PBR_R.GetEpo()            
            
            
            #PBR.SetMotor1(0.15)                  # Set the first motor to the first value in the pair
           # PBR.SetSpeedMotor(5)  
        
#            encoder=PBR.GetEncoderSpeed()
#            print "encoder=", encoder


            time.sleep(stepDelay)                   # Wait between steps
except KeyboardInterrupt:
    # User has pressed CTRL+C
    PBR.MotorsOff()                 # Turn both motors off
    print 'Done'
