#!/usr/bin/env python
# coding: Latin-1

# Simple example of a motor sequence script

# Import library functions we need
import PicoBorgRevEnc as PicoBorgRev
import time


#PBR.SetEncoderSpeed(0.4) 

# Setup the PicoBorg Reverse
PBR2 = PicoBorgRev.PicoBorgRev()     # Create a new PicoBorg Reverse object
PBR2.i2cAddress = 11
PBR2.Init()                          # Set the board up (checks the board is connected)
PBR2.ResetEpo()                      # Reset the stop switch (EPO) state
                                    # if you do not have a switch across the two pin header then fit the jumper

PBR2.SetCommsFailsafe(True)
PBR2.SetEncoderMoveMode(True)
PBR2.SetEpoIgnore(False)


PBR2.SetPIDVariables('KMOT', 0.1)
PBR2.SetPIDVariables('KP', 0.1)
PBR2.SetPIDVariables('KI', 0.1)

#kmot=PBR2.GetPIDVariables('KMOT')
#kp=PBR2.GetPIDVariables('KP')
#ki=PBR2.GetPIDVariables('KI')
#print 'Variables PID:: KMOT=',kmot,' KP=',kp,' KI=',ki


# Set our sequence, pairs of motor 1 and motor 2 drive levels
sequence = [

            [+0.2, -0.2],
            [+0.3, -0.3],
            [+0.4, -0.4],
            [+0.6, -0.6],
            [+0.7, -0.7],
            [+0.6, -0.6],
            [+0.4, -0.4],
            [+0.2, -0.2],
            [+0.0, +0.0],
           ]
sequence = [

            [+0.2, -0.2],
            [+0.3, -0.3],
            [+0.4, -0.4],
            [+0.6, -0.6],
            [+0.7, -0.7],
            [+0.6, -0.6],
            [+0.4, -0.4],
            [+0.2, -0.2],
            [+0.0, +0.0],
           ]           
stepDelay = 0.3                    # Number of seconds between each sequence step

# Loop over the sequence until the user presses CTRL+C
print 'Press CTRL+C to finish'
try:
    while True:
#        PBR.EncoderMoveMotors(20000) 
        # Go through each entry in the sequence in order
        for step in sequence:
#            PBR.SetMotor1(step[0])                  # Set the first motor to the first value in the pair
#            PBR.SetMotor2(step[1])                  # Set the second motor to the second value in the pair
#            print '%+.1f %+.1f' % (step[0], step[1])
#            drivestatus=PBR.GetDriveFault()
#            print "drivestatus= ",drivestatus
#            commstatus=PBR.GetCommsFailsafe()
#            print "commstatus= ",commstatus
#            epostatus=PBR.GetEpo()
#            print "epostatus= ",epostatus
#            PBR.SetMotor1(-0.15)                  # Set the first motor to the first value in the pair
        
            #PBR1 derecha
           
            PBR2.SetSpeedMotor(100)  
        

            encoder=PBR2.GetEncoderSpeed()
            print "encoder 2=", encoder
            drivefaultstatus=PBR2.GetDriveFault()
            print "GetDriveFault= ",drivefaultstatus
            currentstatus=PBR2.GetEpoCurrentState()
            print "GetEpoCurrentState= ",currentstatus
            epostatus=PBR2.GetEpo()
            print "epostatus 2= ",epostatus


            time.sleep(stepDelay)                   # Wait between steps
except KeyboardInterrupt:
    # User has pressed CTRL+C

    PBR2.MotorsOff()    
    print 'Done'
