#!/usr/bin/env python

import rospy

from std_msgs.msg import String
from base_sacarino_msgs.msg import *
from geometry_msgs.msg import Twist

import time
import os
import numpy as np;
import json
from array import *
from datetime import timedelta
from threading import Thread
import random

#DEFINES

#ALARMS

stepDelay = 0.3                    # Number of seconds between each sequence step
Max_vel_f=0.65
Max_vel_f_min=0.35
Max_vel_b=-0.35
accel=0.01


SAFETY_STOP_FRONT=500
SAFETY_STOP_BACK=300
SAFETY_STOP_SIDE=300

global step_mode
sequence_mode=['forward','stop','back','stop','turn','turnning','stop']
turn_option=[{0.1,1.3},{0.1,1.5},{0.1,-1.3},{0.1,-1.5}]
turn_lin=[0.1,0.0,0.15]
turn_ang=[1.3,1.5,1.2,-1.3,-1.5,-1.2]
global count_time_mode
global current_state
global current_sonar_state
global last_vel
global turn

def callback_robot_state(msg):
    pass
    
def callback_sonar_state(msg):
    
    global current_sonar_state

    current_sonar_state=msg

           
   
def update():     

    global step_mode
    global last_vel
    global count_time_mode
    global turn
    
    vel_lin_current=0
    vel_ang_current=0
      
    while not rospy.is_shutdown():
        
        change_mode=False 
        command=Control_command()
        command.digital_command=[False,False,False,False]
        
        mode=sequence_mode[step_mode]
        print mode
        
        
        if mode=='stop':        
            vel_lin_current=0
            change_mode=True
            
        else:
            if mode=='forward':
                
               
                vel_lin_current=last_vel + accel
                vel_lin_current=max(vel_lin_current,Max_vel_f_min)
                if vel_lin_current>Max_vel_f:
                    vel_lin_current=Max_vel_f
                    
                vel_ang_current=0.0
                print 'vel_lin_current=',vel_lin_current
                

       
            elif mode=='back':
                
                vel_lin_current=Max_vel_b

                count_time_mode+=1
                if count_time_mode>20:
                    #vel_lin_current=0
                    change_mode=True
                
            elif mode=='turn':
    
                #turn=list(random.choice(turn_option))
                turn=random.choice(turn_ang)
                change_mode=True
                count_time_mode=0

                    
            elif mode=='turnning':
    
                
                #vel_lin_current=turn_option[0][0]
                #vel_ang_current=turn_option[0][1]
                vel_lin_current=0.1
                vel_ang_current=turn
                count_time_mode+=1
                if count_time_mode>20:
                    #vel_lin_current=0
                    #vel_ang_current=0
                    change_mode=True
        

            if mode=='back':
                print 'SONARS::back ',current_sonar_state.son_values
                #SONAR
                try:
                    safety_dist=SAFETY_STOP_BACK
                    for i in range(4,7):
                        if current_sonar_state.son_values[i]<(safety_dist):
                            print 'STOP SONAR n=',i,' val=', current_sonar_state.son_values[i]
                            
            #                    command.vel_right=0
            #                    command.vel_left=0
            #                    current_vel=0
            #                    pub_msg_command.publish(command)
                            vel_lin_current=0
                            vel_ang_current=0
                            change_mode=True
                except:
                    vel_lin_current=0
                    vel_ang_current=0
                        
            elif mode!='turn':
                print 'SONARS::forward ',current_sonar_state.son_values
                #SONAR
                try:
                    for i in range(0,3):
                        safety_dist=SAFETY_STOP_FRONT
                        if i==1 or i==2:
                            safety_dist=SAFETY_STOP_SIDE                            
                        if current_sonar_state.son_values[i]<int(safety_dist+int(vel_lin_current*15)):
                            print 'STOP SONAR n=',i,' val=', current_sonar_state.son_values[i]
                            
            #                    command.vel_right=0
            #                    command.vel_left=0
            #                    current_vel=0
            #                    pub_msg_command.publish(command)
                            vel_lin_current=0
                            vel_ang_current=0
                            change_mode=True

                except:
                    vel_lin_current=0
                    vel_ang_current=0
                    
            last_vel=vel_lin_current
            
            
            Command_velocity(vel_lin_current,vel_ang_current)
            
        
        if change_mode:
            
            step_mode=step_mode+1
            if step_mode > (len(sequence_mode)-1):
                step_mode=0
            print ' CHANGE MODE: ',sequence_mode[step_mode]
        
        time.sleep(stepDelay)                   # Wait between steps
        
        

    print 'Shutdown'        

def Command_velocity(vel_lin,vel_ang):
    
    vel_command=Twist()

    vel_command.linear.x=vel_lin
    vel_command.linear.y=0.0
    vel_command.linear.z=0.0
    vel_command.angular.x=0.0
    vel_command.angular.y=0.0
    vel_command.angular.z=vel_ang

    pub_msg_vel.publish(vel_command)
    print 'vel_lin=',vel_lin,'vel_ang',vel_ang        
if __name__ == "__main__":
 
    rospy.init_node('roomba')
    
    rospy.Subscriber('robot_control/state',Control_state,callback_robot_state)
    rospy.Subscriber('robot_control/sonar_state',Sonar_state,callback_sonar_state)
    pub_msg_vel=rospy.Publisher('base_control/vel_command', Twist,queue_size=1)
    

    global current_state,current_sonar_state
    current_state=Control_state()
    current_sonar_state=Sonar_state()
    
    global last_vel
    last_vel=0
    
    global step_mode
    step_mode=0
    
    global count_time_mode
    count_time_mode=0
    global turn
    turn=[]
    
    thread_update = Thread(target=update)
    time.sleep(0.5) 
    thread_update.start() 
    

    print "Started"
    rospy.spin()
    

