#!/usr/bin/env python

import rospy
import bluetooth
import math
import time
from threading import Thread


from geometry_msgs.msg import Twist

global intensidadAnt
global radsAnt
A = 0.7

def filtrarParam(intensidad,rads):
	global intensidadAnt
	global radsAnt
	print "inten intenAnt, ", intensidad
	print "inten intenAnt, ", intensidadAnt
	intensidad = intensidad - A * (intensidad - intensidadAnt)

	rads = rads - A*(rads - radsAnt)

	intensidadAnt = intensidad

	radsAnt = rads
	

def Command_velocity(ang,intensidad):
    
	vel_command=Twist()
	if ang > 180:
		intensidad = -intensidad
		ang = ang - 180
	
	rads = float(ang * math.pi / 180 - math.pi/2)


	filtrarParam(intensidad,rads)

	#print "inten,ang: ",intensidad,rads

	vel_command.linear.x= float(intensidad / 100)
	vel_command.linear.y=0.0
	vel_command.linear.z=0.0
	vel_command.angular.x=0.0
	vel_command.angular.y=0.0
	vel_command.angular.z = rads

	pub_msg_vel.publish(vel_command)    


# main
def main():

	server_sock=bluetooth.BluetoothSocket( bluetooth.RFCOMM )

#	port = bluetooth.get_available_port( bluetooth.RFCOMM )
	port = 0
	server_sock.bind(("",port))
	server_sock.listen(1)
	print "listening on port %d" % port

	uuid = "1e0ca4ea-299d-4335-93eb-27fcfe7fa899"
	bluetooth.advertise_service( server_sock, "FooBar Service", uuid )

#	print "Service advertised"
#	client_sock,address = server_sock.accept()
#	print "Accepted connection from ",address

#	while 1:
#		data = client_sock.recv(1024)
#		print "received [%s]" % data

	while not rospy.is_shutdown():
		try:
			client_sock, client_info = server_sock.accept()
			print "Accepted connection from ",client_info
			while True and not rospy.is_shutdown():
				data = client_sock.recv(1024)
				if len(data) == 0:
					break
				print "received [%s]" % data
				
				try:
					datString = str(data).split(";")
					angArray = datString[0].split(":")
					intenArray = datString[1].split(":")

					ang = float(angArray[1])
					inten = float(intenArray[1])
					Command_velocity(ang,inten)
				except:
					pass
							
		except IOError:
			pass
		except KeyboardInterrupt:
			print "Stopping..."
			stop_advertising(server_sock)
			sys.exit()  

	print("disconnected")


	client_sock.close()
	server_sock.close()

if __name__ == '__main__':
	rospy.init_node('SACARINO_bluetooth_server')
	pub_msg_vel=rospy.Publisher('base_control/vel_command', Twist,queue_size=1)
	global intensidadAnt
	intensidadAnt = 0.0
	global radsAnt
	radsAnt = 0.0
	thread_update = Thread(target=main)
	time.sleep(0.5)
	thread_update.start() 
	rospy.spin()
