#!/usr/bin/env python

import rospy
import std_srvs.srv 
from std_msgs.msg import String
from ir_localization_msgs.msg import IrArray, IrPoint

import time
from picamera.array import PiRGBArray
from picamera import PiCamera
import cv2
import cv2.cv as cv
import numpy as np;
#from matplotlib import pyplot as plt

from array import *

from dateutil import parser
from dateutil import tz
from datetime import datetime
from datetime import timedelta

from threading import Thread



global b_capture



def callback_camera_start(req):

    print "callback_camera_start Response"
    
    global b_capture
    b_capture=True
    
    
    return std_srvs.srv.EmptyResponse();
    
    #return std_srvs.srv.TriggerResponse(True,'waypoint 1');

    
def callback_camera_stop(req):

    print "callback_camera_stop Response"
    #thread_capture.exit()
    global b_capture
    b_capture=False
    #return std_srvs.srv.TriggerResponse(True,'waypoint 1');
    return std_srvs.srv.EmptyResponse();

def pub_ir_array(points):
    
    ir=IrArray()
    #for i in range(len(points)):
        #ir_p=IrPoint()
        #ir_p.x=ir_arraypoints[i][0]
        #ir_p.x=ir_arraypoints[i][1]
        #ir_p.size=ir_arraypoints[i][0]
        #ir.ir_array.append(ir_p)
    
def capture():
    
    global b_capture
    
    print b_capture
    while not rospy.is_shutdown():
        
        if not b_capture:
            rospy.sleep(1)
            
        else:
        
            # capture frames from the camera
            for frame in camera.capture_continuous(rawCapture, format="bgr", use_video_port=True):
                #time1=datetime.now()  
                
                # grab the raw NumPy array representing the image, then initialize the timestamp
                # and occupied/unoccupied text
                #image = blob_detector(frame.array)
                image = blob_detector(frame.array)
                #time2=datetime.now()
                
                # show the frame
                cv2.imshow("Frame", image)
                key = cv2.waitKey(1) & 0xFF
                
                #time3=datetime.now()
                #dt=time2.microsecond-time1.microsecond
                #dt2=time3.microsecond-time1.microsecond
                #print "TIME::",dt,dt2
                
                # clear the stream in preparation for the next frame
                rawCapture.truncate(0)
                
                # if the `q` key was pressed, break from the loop
                if key == ord("q"):
                    break
                
                if rospy.is_shutdown():
                    break
                
                if not b_capture:
                    rawCapture.truncate(0)
                    break
                
    print "shutdown"
  
        
def blob_detector(image):
    
       # Setup SimpleBlobDetector parameters.
    params = cv2.SimpleBlobDetector_Params()
     
    # Change thresholds
    params.minThreshold = 40;
    params.maxThreshold = 200;
     
    # Filter by Area.
    #setting minArea  = 100 will filter out all the blobs that have less then 100 pixels.
    params.filterByArea = True
    params.minArea = 2
     
    # Filter by Circularity
    #Then set appropriate values for minCircularity and maxCircularity.
    #a circle has a circularity of 1, circularity of a square is 0.785, and so on.
    params.filterByCircularity = True
    params.minCircularity = 0.1
     
    # Filter by Convexity
    params.filterByConvexity = True
    params.minConvexity = 0.9
     
    # Filter by Inertia
    params.filterByInertia = True
    params.minInertiaRatio = 0.7 #with 0.1 perfect detection of leds but flase positives
    
    # Filter by Color
    #Set blobColor = 0 to select darker blobs, and blobColor = 255 for lighter blobs.
    params.filterByColor = True
    params.blobColor = 255
    
    #params.minDistBetweenBlobs=1
    gray = cv2.cvtColor(image, cv2.COLOR_BGR2GRAY) 
    ret,thresh = cv2.threshold(gray,127,255,1)
    
    contours,h = cv2.findContours(thresh,1,2)
    
    for cnt in contours:
        approx = cv2.approxPolyDP(cnt,0.01*cv2.arcLength(cnt,True),True)
        print len(approx)
        if len(approx)==5:
            print "pentagon"
            cv2.drawContours(image,[cnt],0,255,-1)
        elif len(approx)==3:
            print "triangle"
            cv2.drawContours(image,[cnt],0,(0,255,0),-1)
        elif len(approx)==4:
            print "square"
            cv2.drawContours(image,[cnt],0,(0,0,255),-1)
        elif len(approx) == 9:
            print "half-circle"
            cv2.drawContours(image,[cnt],0,(255,255,0),-1)
        elif len(approx) > 15:
            print "circle"
            cv2.drawContours(image,[cnt],0,(0,255,255),-1)





    
    return image       
    
if __name__ == "__main__":
    rospy.init_node('picamera_node')
    
    rospy.Service('picamera_node/camera_start',std_srvs.srv.Empty,callback_camera_start)
    rospy.Service('picamera_node/camera_stop',std_srvs.srv.Empty,callback_camera_stop)
    
    #pub_next=rospy.Publisher('picamera_node/mode', String)
    
    camera = PiCamera()
    camera.resolution = (640,480)
    camera.sharpness = 0
    camera.contrast = 40
    #camera.brightness = 20
    camera.saturation = 0
    camera.ISO = 0
    camera.video_stabilization = False
    camera.exposure_compensation = 0
    camera.exposure_mode = 'auto'
    camera.meter_mode = 'average'
    camera.awb_mode = 'auto'
    camera.image_effect = 'none'
    camera.color_effects = None
    camera.rotation = 0
    camera.hflip = False
    camera.vflip = False
    camera.crop = (0.0, 0.0, 1.0, 1.0)
    camera.framerate = 32
    
    
    camera.brightness=rospy.get_param('brightness', 20)
    print "camera.brightness" ,camera.brightness
    rawCapture = PiRGBArray(camera, size=camera.resolution)
    
    global b_capture
    b_capture=True
    
    thread_capture = Thread(target=capture)
    thread_capture.start()
    

    
    print "Started"
    rospy.spin()
