#!/usr/bin/env python

import rospy
import std_srvs.srv 
from std_msgs.msg import String
from raspicam_localization.msg import IrArray, IrPoint

import time
#from picamera.array import PiRGBArray
#from picamera import PiCamera
import os

import cv2
import sys
sys.path.append('/home/edubot/opencv')
import cv2.cv as cv
#import cv2.cv as cv
import numpy as np;
#from matplotlib import pyplot as plt
import math

import yaml

from array import *

from dateutil import parser
from dateutil import tz
from datetime import datetime
from datetime import timedelta

from threading import Thread

im_width=640
im_height=480
#Experimental focal lenth obtained between two distances z1=1m z2=3m Deltaz=2m.
focal_length=2.017 #2.74
#define Z4_ERR_THRESHOLD 0.1
z3_err_threshold=0.1
num_min_ir=2
num_max_ir=7
num_min_mark=2



global b_capture
targets=[]

class Target:
    id_t = ''
    position= []
    corner1 = []
    corner2 = []
    corner3 = []
    corner4 = []


def callback_camera_start(req):

    print "callback_camera_start Response"
    
    global b_capture
    b_capture=True
    
    
    return std_srvs.srv.EmptyResponse();
    
    #return std_srvs.srv.TriggerResponse(True,'waypoint 1');

    
def callback_camera_stop(req):

    print "callback_camera_stop Response"
    #thread_capture.exit()
    global b_capture
    b_capture=False
    #return std_srvs.srv.TriggerResponse(True,'waypoint 1');
    return std_srvs.srv.EmptyResponse();

def pub_ir_array(points):
    
    ir=IrArray()
    for i in range(len(points)):
        ir_p=IrPoint()
        ir_p.x=int(points[i][0])
        ir_p.y=int(points[i][1])
        ir_p.size=int(points[i][2])
        ir.ir_array.append(ir_p)
        
    pub_msg_array.publish(ir)
    
def capture():
    
    global b_capture
    
    print b_capture
    path = '../data/timelapse_ledfueramedio'
     
    #empty list to include files
    lstFiles = []
     
    #list with files
    lstDir = os.walk(path)   #os.walk() with files and folders
     
     
    #list with .jpg extension files
     
    for root, dirs, files in lstDir:
        for ifile in files:
            (name_file, ext) = os.path.splitext(ifile)
            if(ext == ".jpg"):
                lstFiles.append(path+'/'+name_file+ext)
                
    while not rospy.is_shutdown():
        
        if not b_capture:
            rospy.sleep(1)
            
        else:
     
            for namef in lstFiles:
                print namef 

                #time1=datetime.now()  
                
                # grab the raw NumPy array representing the image, then initialize the timestamp
                # and occupied/unoccupied text
                img = cv2.imread(namef)
                image = blob_detector(img)
                #time2=datetime.now()
                
                # show the frame
                cv2.imshow("Frame", img)
                cv2.imshow("Detect", image)
                #plt.subplot(121), plt.imshow(img)
                #plt.subplot(122), plt.imshow(image)
                #plt.show()
                
                key = cv2.waitKey(0) 
                
                #time3=datetime.now()
                #dt=time2.microsecond-time1.microsecond
                #dt2=time3.microsecond-time1.microsecond
                #print "TIME::",dt,dt2
                
                
                # if the `q` key was pressed, break from the loop
                if key == ord("q"):
                    break
                
                if rospy.is_shutdown():
                    break
            
            break

    cv2.destroyAllWindows()            
    print "shutdown"
  
        
def blob_detector(image):
    
       # Setup SimpleBlobDetector parameters.
    params = cv2.SimpleBlobDetector_Params()
     
    # Change thresholds
    params.minThreshold = 10;
    params.maxThreshold = 250;
    params.thresholdStep = 10;
     
    # Filter by Area.
    #setting minArea  = 100 will filter out all the blobs that have less then 100 pixels.
    params.filterByArea = True
    params.minArea = 2
    #params.maxArea = 200
     
    # Filter by Circularity
    #Then set appropriate values for minCircularity and maxCircularity.
    #a circle has a circularity of 1, circularity of a square is 0.785, and so on.
    params.filterByCircularity = True
    params.minCircularity = 0.2
     
    # Filter by Convexity
    params.filterByConvexity = True
    params.minConvexity = 0.1
     
    # Filter by Inertia
    params.filterByInertia = True
    params.minInertiaRatio = 0.5 #with 0.1 perfect detection of leds but false positives
    
    # Filter by Color
    #Set blobColor = 0 to select darker blobs, and blobColor = 255 for lighter blobs.
    params.filterByColor = True
    params.blobColor = 255
    
    #params.minDistBetweenBlobs=1
     
    # Create a detector with the parameters
    ver = (cv2.__version__).split('.')
    if int(ver[0]) < 3 :
        detector = cv2.SimpleBlobDetector(params)
    else : 
        detector = cv2.SimpleBlobDetector_create(params)


    #ret,thresh1 = cv2.threshold(image,127,255,cv2.THRESH_BINARY)
    gray = cv2.cvtColor(image, cv2.COLOR_BGR2GRAY)
    kernel = np.ones((3,3),np.uint8)
    erosion = cv2.erode(gray,kernel,iterations = 1)


    
    # Detect blobs.
    keypoints = detector.detect(erosion)
     
    # Draw detected blobs as red circles.
    # cv2.DRAW_MATCHES_FLAGS_DRAW_RICH_KEYPOINTS ensures the size of the circle corresponds to the size of blob
    im_with_keypoints = cv2.drawKeypoints(erosion, keypoints, np.array([]), (0,0,255), cv2.DRAW_MATCHES_FLAGS_DRAW_RICH_KEYPOINTS)

    if num_min_ir<len(keypoints)<num_max_ir:
        points=point_filter(keypoints)    
        #print points
        pub_ir_array(points)
    
    
    #marks
        if len(points)>=num_min_mark:
            
            if len(points)==3:
                print "partial mark detected"
        
            if len(points)==4:
                print "full mark detected"
                normal_points=mark_preprocess_points(points)
                #mark_detection(normal_points)
                
                #Posit
                print "CVPOSIT"
                blob_centers=[]
                #for i in range(len(points)):
                    #blob_centers.append((points[i][0]-im_width/2.0,im_height/2.0-points[i][1]))
                
                blob_centers.append((normal_points[2][0],normal_points[2][1]))
                blob_centers.append((normal_points[0][0],normal_points[0][1]))   
                blob_centers.append((normal_points[1][0],normal_points[1][1]))   
                blob_centers.append((normal_points[3][0],normal_points[3][1]))   
                print blob_centers
                #3d model 
                modelepoints=[]

                modelepoints.append((0.0,0.0,0.0))
                modelepoints.append((0.0,8.0,-2.1))
                modelepoints.append((-5.0,-2.0,-2.1))
                modelepoints.append((5.0,-2.0,-2.1))
                
                #modelepoints.append((0.0,8.0,2.1))
                #modelepoints.append((0.0,0.0,0.0))
                #modelepoints.append((-5.0,10.0,0.0))
                #modelepoints.append((5.0,10.0,0.0))
                pos_mat= find_pose(4,blob_centers,modelepoints)
                
                #draw
                projectedPoints=[]
                for i in range(len(modelepoints)):
                    
                    point3D_x=pos_mat[0][0]*modelepoints[i][0]+pos_mat[0][1]*modelepoints[i][1]+pos_mat[0][2]*modelepoints[i][2]+pos_mat[3][0]
                    point3D_y=pos_mat[1][0]*modelepoints[i][0]+pos_mat[1][1]*modelepoints[i][1]+pos_mat[1][2]*modelepoints[i][2]+pos_mat[3][1]
                    point3D_z=pos_mat[2][0]*modelepoints[i][0]+pos_mat[2][1]*modelepoints[i][1]+pos_mat[2][2]*modelepoints[i][2]+pos_mat[3][2]
                    
                    
                    point2D_x=0.0
                    point2D_y=0.0
                    if  point3D_z != 0 :
                        point2D_x=1000*point3D_x/point3D_z
                        point2D_y=1000*point3D_y/point3D_z
                        
                    projectedPoints.append((point2D_x,point2D_y))

                centreX=im_width/2.0
                centreY=im_height/2.0
                point0_x=centreX + int(projectedPoints[0][0])
                point0_y=centreY - int(projectedPoints[0][1])
                point1_x=centreX + int(projectedPoints[1][0])
                point1_y=centreY - int(projectedPoints[1][1])
                point2_x=centreX + int(projectedPoints[2][0])
                point2_y=centreY - int(projectedPoints[2][1])
                point3_x=centreX + int(projectedPoints[3][0])
                point3_y=centreY - int(projectedPoints[3][1])
                
                cv2.line( im_with_keypoints,(int(point0_x),int(point0_y)),(int(point1_x),int(point1_y)),(255,0,0),2)
                cv2.line( im_with_keypoints,(int(point0_x),int(point0_y)),(int(point2_x),int(point2_y)),(0,255,0),2)
                cv2.line( im_with_keypoints,(int(point0_x),int(point0_y)),(int(point3_x),int(point3_y)),(0,0,255),2)
                
                #cv2.line( im_with_keypoints,(int(point0_x),int(point0_y)),(int(point0_x),int(point0_y-8)),(255,200,0),1)
                #cv2.line( im_with_keypoints,(int(point0_x),int(point0_y)),(int(point0_x-5),int(point0_y+2)),(200,255,0),1)
                #cv2.line( im_with_keypoints,(int(point0_x),int(point0_y)),(int(point0_x+5),int(point0_y+2)),(200,0,255),1)
            
            
            #minEnclosingCircle
            aux_p=[]
            for i in range(len(points)):
                p=(int(points[i][0]),int(points[i][1]))
                aux_p.append(p)
            nppoints=np.array(aux_p)
            (x,y),radius = cv2.minEnclosingCircle(nppoints)
            center = (int(x),int(y))
            radius = int(radius)+20
            color=(255,0,0)
            if len(points)==4:
                color=(0,255,0)

            #im = cv2.circle(im_with_keypoints,center,radius,color,2)
 
    return im_with_keypoints
def find_pose(nb_pts,points2d,points3d):


    # position of 3d model detected in image with respect to camera
    pos_mat = ((1,0,0,0),(0,1,0,0),(0,0,1,0),(0,0,0,1))
    
    focal_length = 1000 #scale factor: number of pixels per focal length
    
    # create posit object
    positObject = cv.CreatePOSITObject(points3d)
    print positObject
    rotation_matrix=cv.CreateMat(3,3,cv.CV_64FC1)
    translation_vector=cv.CreateMat(3,1,cv.CV_64FC1)
    criteria = (cv.CV_TERMCRIT_EPS, 0, 0.01) 
    (rotation_matrix, translation_vector) = cv.POSIT( positObject, points2d, focal_length, criteria)
    pos_mat = ((rotation_matrix[0][0],rotation_matrix[0][1], rotation_matrix[0][2],0),
               (rotation_matrix[1][0],rotation_matrix[1][1], rotation_matrix[1][2],0),
                (rotation_matrix[2][0],rotation_matrix[2][1], rotation_matrix[2][2],0),
                (translation_vector[0],translation_vector[1],translation_vector[2],1))
    
    print "POINT 3D"
    for i in range(len(points3d)):
        print points3d[i]
        
    print "POINT 2D"
    for i in range(len(points2d)):
        print points2d[i]
        
    print "ROTATION"
    for i in range(len(rotation_matrix)):
        print rotation_matrix[i]
        
    heading = math.atan2(rotation_matrix[2][2],rotation_matrix[0][0]);
    bank = math.atan2(-rotation_matrix[2][0],rotation_matrix[1][2]);
    attitude = math.asin(rotation_matrix[1][1]);
    print"euler=",(heading*180/math.pi),(bank*180/math.pi),(attitude*180/math.pi)  
    print "TRANSLATION"
    for i in range(len(translation_vector)):
        print translation_vector[i]
        
    #print "POS_MAT"
    #for i in range(len(pos_mat)):
       # print pos_mat[i]
            
    return pos_mat
  
def point_filter(kpoints):
    points=[]
    aux_size=[]
    
    #filter by size
    #calculate median of sizes
    for i in range(len(kpoints)):        
        aux_size.append(kpoints[i].size)
       
    size_points=np.array(aux_size)
    median=np.median(size_points)
    #print median
 
    
    for i in range(len(kpoints)):
        if (median-3.0)<kpoints[i].size<(median+3.0):
            p=(kpoints[i].pt[0],kpoints[i].pt[1],kpoints[i].size)
            points.append(p)
        
            #print i,p
        
    return points
    
def mark_preprocess_points(points):
    
    #order the detected points in a specific arrangement for further processing
    #1 upper point -> minim y
    mark_points=[]
    miny=im_height
    iappend=5
    for i in range(len(points)):
        if points[i][1] < miny:
            miny=points[i][1]
            iappend=i
    mark_points.append(points[iappend])
    
    #2 left point minim x
    
    minx=im_width
    for i in range(len(points)):
        if i != iappend:
            if len(mark_points)>1:
                for j in range(1,len(mark_points)):  
                    
                    if points[i][0] < mark_points[j][0] :
                        mark_points.insert(j,points[i])
                        #print "insert"
                        break
                    
                    elif j == len(mark_points)-1:
                        mark_points.append(points[i])
                        #print "append"
            else:
                mark_points.append(points[i])
                
    #2D information normalized             
    for i in range(len(mark_points)):
        norm_x=(mark_points[i][0]-im_width/2.0)
        norm_y=(im_height/2.0-mark_points[i][1])
        
        #norm_x=(mark_points[i][0]-im_width/2.0)*(2.0/im_width)
        #norm_y=(im_height/2.0-mark_points[i][1])*(2.0/im_width)
        mark_points[i]=(norm_x,norm_y,mark_points[i][2])
        #print mark_points[i]
    
    return mark_points
    
def mark_detection(points):
    
    delta13_x=abs(points[3][0]-points[1][0])
    delta13_y=abs(points[3][1]-points[1][1])
    delta02_x=abs(points[2][0]-points[0][0])
    delta02_y=abs(points[2][1]-points[0][1])
    
    atanxz=math.atan2(points[2][0],focal_length)
    atanyz=math.atan2(points[2][1],focal_length)
    #print "resta::", points[3][0],points[1][0]
    print "deltas::", delta13_x, delta13_y,delta02_x,delta02_y
    print "atan", atanxz,atanyz

    m=delta13_y/delta13_x
    z3_err=abs((points[2][0]-points[1][0])*m-(points[1][1]-points[2][1]))
    
    print "err::", z3_err,delta13_y,delta13_x
    #Check if the point 3 [2] is in the line between 2 [1] and 4 [3] and line between 1 and 3 is vertical
    #if z3_err<z3_err_threshold and (abs(delta13_y)>abs(5.0*delta13_x)):
    if z3_err<z3_err_threshold:
        #Dimension of the mark in m
        height_target=abs(targets[0].corner1[1]-targets[0].corner3[1])
        phi=math.atan2(targets[0].corner3[0],focal_length)
        p=focal_length/math.cos(phi)
        d=height_target*p/delta02_y
        print "height_target=",height_target 
        print phi,p

        
        #Coordinates of the mark from the sensor
        Xm=d*math.sin(phi)
        Ym=-d*math.cos(phi)
        Zm=points[0][1]*d/p
        
        print "pose::",d,Xm,Ym,Zm
    
    

    #print "targets[0].position[0]",targets[0].position[0]

  
    
if __name__ == "__main__":
    rospy.init_node('picamera_node')
    
    rospy.Service('picamera_node/camera_start',std_srvs.srv.Empty,callback_camera_start)
    rospy.Service('picamera_node/camera_stop',std_srvs.srv.Empty,callback_camera_stop)
    
    pub_msg_array=rospy.Publisher('picamera_node/ir_array', IrArray)
    
    #f = open('../conf/targets.yaml')
    global targets
    
    stream = open('../conf/targets.yaml')
    data = yaml.load(stream)
    stream.close()
    print len(data)
    for i in range(len(data)):
        target=Target()
        t = data['target']
        target.id_t = t['id']
        target.position = t['position']
        target.corner1 = t['corner1']
        target.corner2 = t['corner2']
        target.corner3 = t['corner3']
        target.corner4 = t['corner4']
        
        targets.append(target)
    
    
    global b_capture
    b_capture=True
    
    thread_capture = Thread(target=capture)
    thread_capture.start()
    

    
    print "Started"
    rospy.spin()
