// Programa que se suscribe a turtlesim  a pose y color

#include "ros/ros.h"
#include "turtlesim/Color.h"
#include "turtlesim/Pose.h"


//Topic Callbacks

void color_callback(const turtlesim::Color::ConstPtr& col)
{
	ROS_INFO("rojo: %d,verde: %d, azul: %d", col->r,col->g,col->b);
}


void pose_callback(const turtlesim::Pose& pos)
{

	ROS_INFO_STREAM(std::setprecision(2) << std::fixed<<
		"posicion=(" << pos.x << "," << pos.y << ")"
		<< "direccion=" << pos.theta);

}

int main(int argc, char **argv)
{
	ros::init(argc,argv,"subtsim");
	ros::NodeHandle node;

	ros::Subscriber sub_color = node.subscribe("turtle1/color_sensor",1000,color_callback);
	ros::Subscriber sub_pose = node.subscribe("turtle1/pose",1000,pose_callback);
	ros::spin();
	return 0;
}
