#include <ros/ros.h>
#include <image_transport/image_transport.h>
#include <opencv2/highgui/highgui.hpp>
#include <cv_bridge/cv_bridge.h>
#include <sensor_msgs/CompressedImage.h>

void imageCallback(const sensor_msgs::CompressedImage::ConstPtr& msg)
{
  try
  {
	//cv_bridge::CvImagePtr cv_ptr;
	//cv_ptr =cv_bridge::toCvCopy(msg,sensor_msgs::CompressedImage::"bgr8");
	//cv::Mat matrix =cv::imdecode(cv:Mat(cv_ptr),1);
	//cv::Mat colorFrame=cv::imdecode(msg->data,CV_LOAD_IMAGE_GRAYSCALE);

    //cv::imshow("view", cv_bridge::toCvShare(msg, "bgr8")->image);
	//cv::Mat comp=cv_bridge::toCvShare(msg, "bgr8")->image;
	//cv_bridge::CvImagePtr cv_ptr =cv_bridge::toCvCopy(msg,sensor_msgs::image_encodings::BGR8);
	cv::Mat colorFrame=cv::imdecode(msg->data,CV_LOAD_IMAGE_COLOR);
	
	cv::imshow("view",colorFrame);
    cv::waitKey(30);
  }
  catch (cv::Exception& e)
  {
    ROS_ERROR("Could not convert from '%s' to 'bgr8'.", msg->format.c_str());
	//ROS_ERROR("Could not convert");
  }
}

int main(int argc, char **argv)
{
  ros::init(argc, argv, "image_listener");
  ros::NodeHandle nh;
  cv::namedWindow("view");
  cv::startWindowThread();
  //image_transport::ImageTransport it(nh);
  //image_transport::Subscriber sub = it.subscribe("/image/compressed", 1, imageCallback);
  ros::Subscriber sub=nh.subscribe("/picamera_node/image_raw/compressed", 1, imageCallback);
  ros::spin();
  cv::destroyWindow("view");
}
