// Este programa da la distancia y angulo de la tortuga a una linea ax²+bx+c=0
#include <ros/ros.h>  
#include <camara/siguelinea.h>  // For geometry_msgs::Twist
#include "geometry_msgs/Twist.h"
#include <stdlib.h> // For rand() and RAND_MAX
#include <std_srvs/Empty.h>


double Kd=0.15;	// Ganancia controlador distancia
double Kg=4; 	// Ganancia giro angular

ros::Publisher vel_pub;




void lineaCallback(const camara::siguelinea::ConstPtr & linea){
	double distancia,angulo;
	distancia=linea->distancia;
	angulo=linea->angulo;
	geometry_msgs::Twist msg;
	if(!linea->detectado){
		ROS_INFO_STREAM("Linea no encontrada");
		msg.linear.x=0;
		msg.linear.y=0;
		msg.linear.z=0;
		msg.angular.x=0;
		msg.angular.y=0;
		msg.angular.z=0;
	}else{
		
		msg.linear.x=0.15; //0.3
		msg.linear.y=0;
		msg.linear.z=0;
		msg.angular.x=0;
		msg.angular.y=0;
		msg.angular.z=Kd*distancia+Kg*angulo;
		
		ROS_INFO_STREAM("Velocidad:"<< " lineal=" << msg.linear.x << " angular=" << msg.angular.z << "Kg*angulo" << Kg*angulo);
	}
		vel_pub.publish(msg);

	
	
}

int main(int argc, char **argv) {
  // Initialize the ROS system and become a node.
  ros::init(argc, argv, "sensorlinea");
  ros::NodeHandle nh;

  // Create a publisher object.
  ros::Subscriber sub = nh.subscribe("distancialinea", 100,lineaCallback);
  vel_pub =nh.advertise<geometry_msgs::Twist>("cmd_vel",100);
   

  //ros::service::waitForService("clear");
  //Obtiene valores de los parámetros Kd y Kg.
  const std::string PARAM_NAME1 = "~Kd";
  bool ok = ros::param::get("~Kd",Kd);
  if(!ok) {
    ROS_FATAL_STREAM("No puedo obtener parametro " << PARAM_NAME1);
    exit(1);
  }
   const std::string PARAM_NAME2 = "~Kg";
   ok = ros::param::get(PARAM_NAME2,Kg);
  if(!ok) {
    ROS_FATAL_STREAM("No puedo obtener parametro " << PARAM_NAME2);
    exit(1);
  }

  
  ros::spin();
  return 0;
   
   
    
    
  
}


