// Este programa da la distancia y angulo de la tortuga a una linea ax²+bx+c=0
#include <ros/ros.h>  
#include <robotsim/siguelinea.h>  // For geometry_msgs::Twist
#include "geometry_msgs/Twist.h"
#include <turtlesim/TeleportAbsolute.h>
#include <stdlib.h> // For rand() and RAND_MAX
#include <std_srvs/Empty.h>


double Kd=1.5;	// Ganancia controlador distancia
double Kg=4; 	// Ganancia giro angular

ros::Publisher vel_pub;




void lineaCallback(const robotsim::siguelinea::ConstPtr & linea){
	double distancia,angulo;
	distancia=linea->distancia;
	angulo=linea->angulo;

	geometry_msgs::Twist msg;
	msg.linear.x=2;
	msg.linear.y=0;
	msg.linear.z=0;
	msg.angular.x=0;
	msg.angular.y=0;
	msg.angular.z=Kd*distancia+Kg*angulo;
	vel_pub.publish(msg);
	

	
	//ROS_INFO_STREAM("Velocidad:"<< " lineal=" << msg.linear.x << " angular=" << msg.angular.z);
}

int main(int argc, char **argv) {
  // Initialize the ROS system and become a node.
  ros::init(argc, argv, "sensorlinea");
  ros::NodeHandle nh;

  // Create a publisher object.
  ros::Subscriber sub = nh.subscribe("distancialinea", 100,lineaCallback);
  vel_pub =nh.advertise<geometry_msgs::Twist>("/turtle1/cmd_vel",100);
   

  ros::service::waitForService("clear");
  // Obtiene valores de los parámetros Kd y Kg.
  const std::string PARAM_NAME1 = "~Kd";
  bool ok = ros::param::get("~Kd",Kd);
  if(!ok) {
    ROS_FATAL_STREAM("No puedo obtener parametro " << PARAM_NAME1);
    exit(1);
  }
   const std::string PARAM_NAME2 = "~Kg";
   ok = ros::param::get(PARAM_NAME2,Kg);
  if(!ok) {
    ROS_FATAL_STREAM("No puedo obtener parametro " << PARAM_NAME2);
    exit(1);
  }

  ros::ServiceClient clearClient =nh.serviceClient<std_srvs::Empty>("/clear");
	std_srvs::Empty srv1;
	clearClient.call(srv1);



  //ros::NodeHandle n;
  //Llamada a servicio para posicionar la tortuga
  ros::ServiceClient client = nh.serviceClient<turtlesim::TeleportAbsolute>("/turtle1/teleport_absolute");
  turtlesim::TeleportAbsolute srv;
  srv.request.x = 1.0;
  srv.request.y = 5.0;
  srv.request.theta=0.0;
  if (client.call(srv))
  {
    ROS_INFO_STREAM("Posicionado en x= "<< srv.request.x << " y=" <<  srv.request.y << " theta= " << srv.request.x);
ROS_INFO_STREAM("Kd="<< Kd << " Kg=" <<  Kg);
  }
  else
  {
    ROS_ERROR_STREAM("Failed to call service");
    return 1;
  }

  ros::spin();
  return 0;
   
   
    
    
  
}


