// Este programa da la distancia y angulo de la tortuga a una linea ax²+bx+c=0
#include <ros/ros.h>  
#include <robotsim/siguelinea.h>  // For geometry_msgs::Twist
#include "turtlesim/Pose.h"
#include <stdlib.h> // For rand() and RAND_MAX


turtlesim::Pose turtlesim_pose;
void poseCallback(const turtlesim::Pose::ConstPtr & pose_message){
	turtlesim_pose.x=pose_message->x;
	turtlesim_pose.y=pose_message->y;
	turtlesim_pose.theta=pose_message->theta;
	//ROS_INFO_STREAM("Pose tortuga:"<< " x=" << pose_message->x << " y=" << pose_message->y << " theta=" << pose_message->theta);
}

int main(int argc, char **argv) {
  // Initialize the ROS system and become a node.
  ros::init(argc, argv, "sensorlinea");
  ros::NodeHandle nh;

  // Create a publisher object.
  ros::Publisher pub = nh.advertise<robotsim::siguelinea>(
    "distancialinea", 1000);

  ros::Subscriber pose_subscriber =nh.subscribe("/turtle1/pose",100,poseCallback);
 
  // Loop at 5Hz until the node is shut down.
  ros::Rate rate(5);
  robotsim::siguelinea msg;
  // recta ax²+by+c=0;
  double a=1,b=-1,c=0;
  while(ros::ok()) {
  ros::spinOnce(); 
     


   msg.distancia=(a*turtlesim_pose.x+b*turtlesim_pose.y+c)/sqrt(a*a+b*b);
   msg.angulo=atan(-a/b)-turtlesim_pose.theta;

   
    // Publish the message.
    pub.publish(msg);

    // Send a message to rosout with the details.
    
    ROS_INFO_STREAM("Distancia y angulo a recta:" << " distancia=" << msg.distancia << " angulo=" << msg.angulo*180/3.1416);

    // Wait until it's time for another iteration.
    rate.sleep();
  }
}


